#!/bin/sh

update_busybox ()
{
    diff /bin/busybox_patch /thunder/bin/busybox
    if [ "$?" -eq "0" ]; then
    echo "busybox"
    else
    cp -a /thunder/bin/busybox /bin/busybox_patch
    fi
}

check_ramlist ()
{
    /bin/busybox cat /thunder/scripts/ramlist.txt | while read RAM_FILE
    do
    if [ ! -x $RAM_FILE ];then
    /bin/busybox ln -s /bin/busybox $RAM_FILE
    echo "make link for $RAM_FILE"
    fi    
    done
}

init_env ()
{
    chmod 711 /etc/passwd*
    chown 711 /etc/shadow*
    chown root /etc/passwd*
    chown root /etc/shadow*
    chgrp root /etc/passw*
    chgrp root /etc/shadow*
    /bin/busybox cp -a /thunder/etc/opkg /etc/
    /bin/busybox cp -a /thunder/etc/securetty /etc/
    HOST_NAME=`/thunder/bin/readkey sn | grep "data:" | sed 's/.*\(....\)$/\1/'`
    echo XL_MINER_$HOST_NAME > /etc/hostname
    export PATH=$PATH:/thunder/bin
    export LD_LIBRARY_PATH=/thunder/lib
    check_ramlist
    /thunder/bin/ubusd -s /var/run/ubus.sock  &
    sleep 1
    /thunder/bin/uhttpd -p 127.0.0.1:80 -u /ubus -a -h /thunder/www &
    /thunder/bin/minissdpd -i eth0 -i lo
    /thunder/bin/pdnsd -d
    touch /tmp/.xunlei_msgqueue
    touch /tmp/.xunlei_module_queue
    touch /tmp/.mnt_usb_queue
    SOFTMODE=`/thunder/bin/envread xl_softmode` 
    /usr/sbin/fw_setenv enable_halt 0
    #iptables -t nat -A PREROUTING -i br0 -p udp --dport 53 -j DNAT --to $(nvram get lan_ipaddr)
    #iptables -t nat -A PREROUTING -i br0 -p tcp --dport 53 -j DNAT --to $(nvram get lan_ipaddr)
}

run_app ()
{
    /bin/sh /thunder/etc/start_app.sh  &
   
    /bin/sh /thunder/etc/sync_data.sh & 
    #enable to boot the explore tool , if the path is exit in the file /thunder/etc/backlist.txt    
    grep run_explore_node.sh /thunder/etc/backlist.txt
    if [ $? -eq 0 ]; then 
    /bin/sh /thunder/bin/run_explore_node.sh &
    else
    echo "disable run explore module"
    fi
}

run_sys ()
{

    /thunder/bin/syswatch &
    /thunder/app/thunder/lib/EmbedThunderManager 0 > /dev/null &
    exit 0
}

SOFTMODE=`/thunder/bin/envread xl_softmode`
init_env

if [ "$SOFTMODE" == "factory" ]; then
mv /etc/securetty /etc/securetty_bak
echo 2 > /sys/class/gpio/export
echo 3 > /sys/class/gpio/export
echo 4 > /sys/class/gpio/export
echo 5 > /sys/class/gpio/export
echo 6 > /sys/class/gpio/export
echo out > /sys/class/gpio/gpio2/direction
echo out > /sys/class/gpio/gpio3/direction
echo out > /sys/class/gpio/gpio4/direction
echo in > /sys/class/gpio/gpio5/direction
echo in > /sys/class/gpio/gpio6/direction
#cp -a /thunder/bin/busybox_fac /bin/busybox 
cp -a /thunder/etc/shadow /etc/shadow
sync
/thunder/bin/factory_app
else
update_busybox
run_app
fi

