#!/bin/sh


# Generate coredump.
ulimit -c unlimited
echo "/tmp/dcdn_base/debug/core-%e-%p-%t" > /proc/sys/kernel/core_pattern

# Set stack size(KB).
ulimit -s 1024


run_module ()
{
    /thunder/bin/$1 > /dev/null  &
    /thunder/bin/ubus wait_for $1 -t 3
    echo -e "`date '+%Y-%m-%d %T'` <INFO>\t$1 running\t-- start_app.sh" >>/var/log/ubus_app.log
}

monitor_modules ()
{
    APP_MODULES="netcfg mnt upgrade xqos upnp_client dcdn remote"
    for name in $APP_MODULES
    do
        /thunder/bin/ubus call $name get_status -t 30 >/dev/null 2>&1
        if [[ $? -eq 7 || $? -eq 4 ]]; then          #Request timed out(7) OR Object not found(4)
            (killall $name && sleep 2 && killall -9 $name) >/dev/null 2>&1
            run_module $name
        fi
    done
}

while :
do
    monitor_modules
    sleep 10
done
